{plugin gapless output}

unit defs;

interface

uses
	Windows, SysUtils, Forms, MMSystem, Messages, Classes, WAmpMsg;

type
	PShortInt = ^ShortInt;

	ConfigProc = procedure(hwndParent : HWND); cdecl;
	AboutProc = procedure(hwndParent : HWND); cdecl;
	GetFileInfoProc = procedure(afile, title : PChar; length_in_ms : PInteger); cdecl;
	InfoBoxProc = function(afile : PChar; hwndParent : HWND) : Integer; cdecl;
	IsOurFileProc = function(afile : PChar) : Integer; cdecl;
	PlayProc = function(fn : PChar) : Integer; cdecl;
	IsPausedProc = function : Integer; cdecl;
	GetLengthProc = function : Integer; cdecl;
	GetOutputTimeProc = function : Integer; cdecl;
	SetOutputTimeProc = procedure(time_in_ms : Integer); cdecl;
	SetVolumeProc = procedure(volume : Integer); cdecl;
	SetPanProc = procedure(pan : Integer); cdecl;
	SAVSAInitProc = procedure(maxlatency_in_ms, srate : Integer); cdecl;
	SAAddPCMDataProc = procedure(PCMData : Pointer; nch, bps, timestamp : Integer); cdecl;
	SAGetModeProc = function : Integer; cdecl;
	SAAddProc = procedure(data : Pointer; timestamp, csa : Integer); cdecl;
	VSAAddPCMDataProc = procedure(PCMData : Pointer; nch, bps, timestamp : Integer); cdecl;
	VSAGetModeProc = function(specNch, waveNch : PInteger) : Integer; cdecl;
	VSAAddProc = procedure(data : Pointer;timestamp : Integer); cdecl;
	VSASetInfoProc = procedure(nch, srate : Integer); cdecl;
	dsp_isactiveProc = function : Integer; cdecl;
	dsp_dosamplesProc = function(samples : PShortInt; numsamples, bps, nch, srate : Integer) : Integer; cdecl;
	EQSetProc = procedure(aOn : Integer; data : PChar; preamp : Integer); cdecl;
	SetInfoProc = procedure(bitrate, srate, stereo, synched : Integer); cdecl;

	OpenProc = function(samplerate, numchannels, bitspersamp, bufferlenms, prebufferms : Integer) : Integer; cdecl;
	WriteProc = function(buf : PChar; len : Integer) : Integer; cdecl;
	CanWriteProc = function : Integer; cdecl;
	IsPlayingProc = function : Integer; cdecl;
	PauseProc = function(pause : Integer) : Integer; cdecl;
	FlushProc = procedure(t : Integer); cdecl;
	GetWrittenTimeProc = function : Integer; cdecl;

	PWinampOutputPlugin = ^TWinampOutputPlugin;

	PWinampInputPlugin = ^TWinampInputPlugin;
	TWinampInputPlugin = packed Record
		Version : Integer;// module type (IN_VER)
		Description : PChar; // description of module, with version string
		hMainWindow : HWND;	// winamp's main window (filled in by winamp)
		hDllInstance : HINST; // DLL instance handle (Also filled in by winamp)
		FileExtensions : PChar; // 'mp3'+#0+'Layer 3 MPEG'+#0+'mp2'+#0+'Layer 2 MPEG'+#0+'mpg'+#0+'Layer 1 MPEG';
													 // May be altered from Config, so the user can select what they wants
		is_seekable : Integer; // is this stream seekable?
		UsesOutputPlug : Integer; // does this plug-in use the output plug-ins? (musn't ever change, ever :)
		Config : ConfigProc; // configuration dialog
		About : AboutProc; // about dialog
		Init : procedure; cdecl;	// called at program init
		Quit : procedure; cdecl; // called at program quit
		GetFileInfo : GetFileInfoProc; // if file == NULL, current playing is used
		InfoBox : InfoBoxProc;
		IsOurFile : IsOurFileProc; // called before extension checks, to allow detection of mms ://, etc


	//***** playback stuff *****//
		Play : PlayProc; // return zero on success, -1 on file-not-found, some other value on other (stopping winamp) error
		Pause : procedure; cdecl; // pause stream
		UnPause : procedure; cdecl; // unpause stream
		IsPaused : IsPausedProc; // ispaused? return 1 if paused, 0 if not
		Stop : procedure; cdecl; // stop (unload) stream


	//***** time stuff *****//
		GetLength : GetLengthProc; // get length in ms
		GetOutputTime : GetOutputTimeProc; // returns current output time in ms. (usually returns outMod->GetOutputTime()
		SetOutputTime : SetOutputTimeProc; // seeks to point in stream (in ms). Usually you signal your thread to seek,
																			// which seeks and calls outMod->Flush()..


	//***** volume stuff *****//
		SetVolume : SetVolumeProc; // from 0 to 255.. usually just call outMod->SetVolume
		SetPan : SetPanProc; // from -127 to 127.. usually just call outMod->SetPan


	//***** in-window builtin vis stuff *****//
		SAVSAInit : SAVSAInitProc; // call once in Play(). maxlatency_in_ms should be the value returned from outMod->Open();
															// call after opening audio device with max latency in ms and samplerate
		SAVSADeInit : procedure; cdecl; // call in Stop()


	//***** simple vis supplying mode *****//
		SAAddPCMData : SAAddPCMDataProc; // sets the spec data directly from PCM data
																		// quick and easy way to get vis working :)
																		// needs at least 576 samples :)


	//***** advanced vis supplying mode, only use if you're cool. Use SAAddPCMData for most stuff. *****//
		SAGetMode : SAGetModeProc; // gets csa (the current type (4=ws,2=osc,1=spec))
															// use when calling SAAdd()
		SAAdd : SAAddProc; // sets the spec data, filled in by winamp


	//***** vis stuff (plug-in) *****//
	//***** simple vis supplying mode *****//
		VSAAddPCMData : VSAAddPCMDataProc; // sets the vis data directly from PCM data
																			// quick and easy way to get vis working :)
																			// needs at least 576 samples :)


	//***** advanced vis supplying mode, only use if you're cool. Use VSAAddPCMData for most stuff. *****//
		VSAGetMode : VSAGetModeProc; // use to figure out what to give to VSAAdd
		VSAAdd : VSAAddProc; // filled in by winamp, called by plug-in
		VSASetInfo : VSASetInfoProc; // call this in Play() to tell the vis plug-ins the current output params.

	//***** dsp plug-in processing *****//
	// (filled in by winamp, called by input plug)
		dsp_isactive : dsp_isactiveProc; // returns 1 if active (which means that the number of samples returned by dsp_dosamples
																		// could be greater than went in.. Use it to estimate if you'll have enough room in the
																		// output buffer
		dsp_dosamples : dsp_dosamplesProc; // returns number of samples to output. This can be as much as twice numsamples.
																			// be sure to allocate enough buffer for samples, then.

	//***** eq stuff *****//
		EQSet : EQSetProc; // 0-64 each, 31 is +0, 0 is +12, 63 is -12. Do nothing to ignore.

		SetInfo : SetInfoProc; // info setting (filled in by winamp)

		OutputPlugin : PWinampOutputPlugin; // filled in by winamp, optionally used
	end;


	TWinampOutputPlugin = packed Record
		Version : Integer; // module version (OUT_VER)
		Description : PChar; // description of module, with version string
		id : Integer;	// module id. each input module gets its own. non-nullsoft modules should be >= 65536.
		hMainWindow : HWND; // winamp's main window (filled in by winamp)
		hDllInstance : HINST; // DLL instance handle (filled in by winamp)
		Config : ConfigProc; // configuration dialog
		About : AboutProc; // about dialog
		Init : procedure; cdecl; // called when loaded
		Quit : procedure; cdecl; // called when unloaded
		Open : OpenProc;
					// returns >=0 on success, <0 on failure
					// NOTENOTENOTE : bufferlenms and prebufferms are ignored in most if not all output plug-ins.
					//    ... so don't expect the max latency returned to be what you asked for.
					// returns max latency in ms (0 for diskwriters, etc)
					// bufferlenms and prebufferms must be in ms. 0 to use defaults.
					// prebufferms must be <= bufferlenms

		Close : procedure; cdecl; // close the ol' output device.

		Write : WriteProc;
					// 0 on success. Len == bytes to write (<= 8192 always). buf is straight audio data.
					// 1 returns not able to write (yet). Non-blocking, always.

		CanWrite : CanWriteProc; // returns number of bytes possible to write at a given time.
													 // Never will decrease unless you call Write (or Close, heh)

		IsPlaying : IsPlayingProc; // non 0 if output is still going or if data in buffers waiting to be
															// written (i.e. closing while IsPlaying() returns 1 would truncate the song

		Pause : PauseProc; // returns previous pause state
		SetVolume : SetVolumeProc;// volume is 0-255
		SetPan : SetVolumeProc; // pan is -128 to 128
		Flush : FlushProc; // flushes buffers and restarts output at time t (in ms)
										 // (used for seeking)

		GetOutputTime : GetOutputTimeProc; // returns played time in MS
		GetWrittenTime : GetWrittenTimeProc; // returns time written in MS (used for synching up vis stuff)
	end;

	function winampGetInModule2 : PWinampInputPlugin; cdecl; export;

	procedure config(hwndParent : HWND); cdecl;
	procedure about(hwndParent : HWND); cdecl;
	procedure init; cdecl;
	procedure quit; cdecl;
	function IsOurFile(fn : PChar) : Integer; cdecl;
	function play(fn : PChar) : Integer; cdecl;
	procedure pause; cdecl;
	procedure unpause; cdecl;
	function ispaused : Integer; cdecl;
	procedure stop; cdecl;
	function getlength : Integer; cdecl;
	function getoutputtime : Integer; cdecl;
	procedure setoutputtime(time_in_ms : Integer); cdecl;
	procedure setvolume(volume : Integer); cdecl;
	procedure setpan(pan : Integer); cdecl;
	procedure getfileinfo(filename, title : PChar;length_in_ms : PInteger); cdecl;
	function InfoBox(afile : PChar; hwndParent : HWND) : Integer; cdecl;
	procedure eq_set(aOn : Integer; data : PChar; preamp : Integer); cdecl;

const
	IN_VER = $100;
	OUT_VER = $10;
	Paused : Byte = 0;

	WM_WA_MPEG_EOF = WM_USER + 2;

	WinampInputPlugin : TWinampInputPlugin =
	(
		Version : IN_VER;
		Description : 'Plugin description';
		hMainWindow : 0;
		hDllInstance : 0;
		FileExtensions : 'cda'+#0+'CD Track'+#0+'mp3'+#0+'MPEG Layer 3'; //accepted extensions
		is_seekable : 1;
		UsesOutputPlug : 0;
		Config : Config;
		About : About;
		Init : Init;
		Quit : Quit;
		GetFileInfo : GetFileInfo;
		InfoBox : InfoBox;
		IsOurFile : IsOurFile;
		Play : Play;
		Pause : Pause;
		UnPause : Unpause;
		IsPaused : IsPaused;
		Stop : Stop;
		GetLength : GetLength;
		GetOutputTime : GetOutputTime;
		SetOutputTime : SetOutputTime;
		SetVolume : SetVolume;
		SetPan : SetPan;
		SAVSAInit : nil;
		SAVSADeInit :  nil;
		SAAddPCMData :  nil;
		SAGetMode :  nil;
		SAAdd :  nil;
		VSAAddPCMData :  nil;
		VSAGetMode :  nil;
		VSAAdd :  nil;
		VSASetInfo :  nil;
		dsp_isactive :  nil;
		dsp_dosamples :  nil;
		EQSet : EQ_Set;
		SetInfo : nil;
		OutputPlugin : nil;
	);

implementation

procedure config(hwndParent : HWND); cdecl;
begin
end;

procedure about(hwndParent : HWND); cdecl;
begin
end;

procedure init; cdecl;
begin
end;

procedure quit;
begin
end;

function IsOurFile(fn : PChar) : Integer;
begin
	//called before check FileExtension
	//check files like 'http://....', return 1 if is your file
	Result := 0;
end;

function play(fn : PChar) : Integer;
begin
	Result := 0;
end;

procedure pause;
begin
	Paused := 1;
end;

procedure unpause;
begin
	Paused := 0;
end;

function ispaused : Integer;
begin
	Result := paused;
end;

procedure stop;
begin
end;

function getlength : Integer;
begin
//	Result := total_time_in_milliseconds
end;

function getoutputtime : Integer;
begin
//	Result := current_time_in_milliseconds
end;

procedure setoutputtime(time_in_ms : Integer);
begin
end;

procedure setvolume(volume : Integer);
begin
end;

procedure setpan(pan : Integer);
begin
end;

procedure getfileinfo(filename, title : PChar; length_in_ms : PInteger);
var
	SongNumber : LongInt;
	FName : PChar;
begin
	if Not Assigned(Filename) or (StrComp(Filename, #0) = 0) then
	begin
		SongNumber := SendMessage(WinampInputPlugin.hMainWindow, WM_WA_IPC, 0, IPC_GETLISTPOS);
		FName := Pointer(SendMessage(WinampInputPlugin.hMainWindow, WM_WA_IPC, SongNumber, IPC_GETPLAYLISTFILE));
	end
	else FName := filename;

	Strcopy(Title, Get_File_Title(FName));

	if Assigned(length_in_ms) then
		length_in_ms^ := Get_File_Length(FName);
end;

function InfoBox(afile : PChar; hwndParent : HWND) : Integer; cdecl;
begin
	Result := 0;
end;

procedure eq_set(aOn : Integer; data : PChar; preamp : Integer);
begin
end;

function winampGetInModule2 : PWinampInputPlugin; cdecl;
begin
	Result := @WinampInputPlugin;
end;

end.
